 // Copyleft (cl) 1999, 2000 by Malekith / The Final Crash of Corp. System
// <malekith@topnet.pl> / <http://malekith.topnet.pl>
// This is part of gallery image viewer. See file copying-left for details.
// Created on Feb 24 2000
// $Id$

#include "main.h"
#include <vgamouse.h>
#include <vgagl.h>
#include <vga.h>

#define PTR_W 16
#define PTR_H 16

#define HOTSPOT_X (PTR_W / 2)
#define HOTSPOT_Y (PTR_H / 2)

void have_a_zoom(int,int,int,int);
void have_a_scroll(int,int);
void have_a_next_pic();

class MousePtr {
	int x,y;
	
	int box_mode, box_dumped, scroll_mode, scrolled;
	byte *b1, *b2, *b3, *b4;
	int x0,y0;
	int x1, y1, x2, y2;
	byte bgd[PTR_W*PTR_H*4];
	int mouse_hidden;
public:
	void hide();
	void show();
	void handler();
	void init();
	void key_pressed() { mouse_hidden = 1; }
	
	MousePtr() : x(-1), y(-1),
	box_mode(0), box_dumped(0), scroll_mode(0), scrolled(0),
	b1(0), b2(0), b3(0), b4(0),
	x0(-1) { }
};

static MousePtr *mptr;

void MousePtr::hide()
{
	if (x == -1)
		return;
	gl_putbox(x - HOTSPOT_X, y - HOTSPOT_Y, PTR_W, PTR_H, bgd);
	
	if (!box_dumped)
		return;
	gl_putbox(x1, y1, 1, y2 - y1 + 1, b1);
	gl_putbox(x2, y1, 1, y2 - y1 + 1, b2);
	gl_putbox(x1, y1, x2 - x1 + 1, 1, b3);
	gl_putbox(x1, y2, x2 - x1 + 1, 1, b4);
	box_dumped = 0;
}

void gl_box(int x, int y, int w, int h, int color)
{
	gl_hline(x, y, x + w, color);
	gl_hline(x, y + h, x + w, color);
	gl_line(x, y, x, y + h, color);
	gl_line(x + w, y, x + w, y + h, color);
}

void MousePtr::show()
{
	if (box_mode) {
		if (!b1) {
			b1 = new byte[(screen_h + 100) * 4];
			b2 = new byte[(screen_h + 100) * 4];
			b3 = new byte[(screen_w + 100) * 4];
			b4 = new byte[(screen_w + 100) * 4];
		}
		if (x0 == -1) {
			x0 = x;
			y0 = y;
		}

		x1 = x <? x0;
		y1 = y <? y0;
		x2 = x >? x0;
		y2 = y >? y0;
		gl_getbox(x1, y1, 1, y2 - y1 + 1, b1);
		gl_getbox(x2, y1, 1, y2 - y1 + 1, b2);
		gl_getbox(x1, y1, x2 - x1 + 1, 1, b3);
		gl_getbox(x1, y2, x2 - x1 + 1, 1, b4);
		box_dumped = 1;
	}
	

	x -= HOTSPOT_X;
	y -= HOTSPOT_Y;
	
	gl_getbox(x >? 0, y >? 0, PTR_W, PTR_H, bgd);

	if (mouse_hidden || scroll_mode) {
		x += HOTSPOT_X;
		y += HOTSPOT_Y;
		return;
	}

	gl_box(x + PTR_W / 4, y + PTR_H / 4, PTR_W / 2, PTR_H / 2, 0);
	gl_box(x + PTR_W * 3 / 8, y + PTR_H * 3 / 8, PTR_W / 4, PTR_H / 4, 0);
	gl_line(x + HOTSPOT_X, y, x + HOTSPOT_X, y + PTR_H - 1, white);
	gl_hline(x, y + HOTSPOT_Y, x + PTR_W - 1, white);

	y >?= 0;
	x >?= 0;
	
	x += HOTSPOT_X;
	y += HOTSPOT_Y;
	
	if (box_mode)
		gl_box(x1, y1, x2 - x1, y2 - y1, white);
}

void MousePtr::handler()
{
	int xx, yy;

	mouse_update();
	
	// never trust deltas ! ;^)
	// if i've had a mouse with wheel, it would be probably used ...
	mouse_getposition_6d(&xx, &yy, 0, 0, 0, 0);
	
	if (x != xx || y != yy)
		mouse_hidden = 0;
			
	x = xx;
	y = yy;

	if (mouse_getbutton() & MOUSE_LEFTBUTTON) {
		box_mode = 1;
		scroll_mode = 0;
		mouse_hidden = 0;
	} else if (box_mode) {
		box_mode = 0;
		x0 = -1;
		mouse_hidden = 0;
		have_a_zoom(x1, y1, x2, y2);
	} else if (mouse_getbutton() & MOUSE_RIGHTBUTTON) {
		if (scroll_mode && (screen_w / 2 - x || screen_h / 2 - y)) {
			scrolled = 1;
			have_a_scroll(screen_w / 2 - x, screen_h / 2 - y);
		}
		mouse_setposition(screen_w / 2, screen_h / 2);
		scroll_mode = 1;
		mouse_hidden = 0;
	} else {
		if (scroll_mode && !scrolled)
			have_a_next_pic();
		scroll_mode = 0;
		scrolled = 0;
	}
}

// exports:
void hide_mouse()
{
	mptr->hide();
}

void show_mouse()
{
	mptr->show();
}

void init_mouse()
{
	vga_setmousesupport(1);
	mptr = new MousePtr;
}

void mouse_frame()
{
	mptr->handler();
}

void key_pressed()
{
	mptr->key_pressed();
}
