// Copyleft (cl) 1999, 2000 by Malekith / The Final Crash of Corp. System
// <malekith@topnet.pl> / <http://malekith.topnet.pl>
// This is part of gallery image viewer. See file copying-left for details.
// Created on Feb 24 2000
// $Id$

#include "main.h"
#include "browser.h"

extern "C" int getclock();

void Browser::have_a_zoom(int x1, int y1, int x2, int y2)
{
	if (x1 > x2) {
		int t = x1;
		x1 = x2;
		x2 = t;
	}
	if (y1 > y2) {
		int t = y1;
		y1 = y2;
		y2 = t;
	}
	int w = x2 - x1, h = y2 - y1;

	if (w <= 1) {
		toggle_fit_screen();
		return;
	}

	if (screen_w * h < screen_h * w) {
		if (w >= on_screen.width())
			return;

		x1 = (x1 + on_screen.x) * screen_w / w;
		y1 = (y1 + on_screen.y) * screen_w / w;
		on_screen.resize_from(orig,
				      on_screen.width() * screen_w / w,
				      (on_screen.width() * screen_w / w) *
				      orig.height() / orig.width());
	} else {
		if (h >= on_screen.height())
			return;

		x1 = (x1 + on_screen.x) * screen_h / h;
		y1 = (y1 + on_screen.y) * screen_h / h;
		on_screen.resize_from(orig,
				      (on_screen.height() * screen_h / h) *
				      orig.width() / orig.height(),
				      (on_screen.height() * screen_h / h)
				      );
	}

	on_screen.x = x1;
	on_screen.y = y1;

	scale = on_screen.width() * 100 / orig.width();
	fit_screen = false;

	update_screen();
}

void Browser::have_a_scroll(int dx, int dy)
{
	if (!dx && !dy)
		return;

	if (on_screen.width() <= screen_w && on_screen.height() <= screen_h)
		return; // picture fits screen and shouldn't be moved
	
	int x = on_screen.x + dx, y = on_screen.y + dy;
	
	x <?= on_screen.width() - screen_w - 1;
	y <?= on_screen.height() - screen_h - 1;
	x >?= 0;
	y >?= 0;

	if (on_screen.x != x || on_screen.y != y) {
		on_screen.x = x;
		on_screen.y = y;
		on_screen.put();
	}
}

void Browser::toggle_fit_screen()
{
	fit_screen = !fit_screen;
	last_action = getclock();
	if (fit_screen) {
		on_screen.resize_from(orig,fs_w,fs_h);
		scale = on_screen.width() * 100 / orig.width();
	} else {
		on_screen.resize_from(orig,orig.width(),orig.height());
		scale = 100;
	}
	update_screen();	
}

void Browser::scale_to(int ns)
{
	if (ns <= 0) return;
	last_action = getclock();
	// remember relative pos
	scale = ns;
	if (on_screen.width() && on_screen.height()) {
		int px = on_screen.x * 10000 / on_screen.width();
		int py = on_screen.y * 10000 / on_screen.height();
	
		on_screen.resize_from(orig,w*scale/100,h*scale/100);
		on_screen.x = px * on_screen.width()  / 10000;
		on_screen.y = py * on_screen.height() / 10000;
	} else {
		on_screen.resize_from(orig,w*scale/100,h*scale/100);
		on_screen.x = on_screen.y = 0;
	}
	
	fit_screen = false;
	
	update_screen();
}

void Browser::handle_arrows(int key)
{
	if (on_screen.width() <= screen_w && on_screen.height() <= screen_h)
		return; // picture fits screen and shouldn't be moved
	int big_pic_x = on_screen.x, big_pic_y = on_screen.y;
	switch (key) {
	case xleft: big_pic_x -= scroll_step; break;
	case xright: big_pic_x += scroll_step; break;
	case xdown: big_pic_y += scroll_step; break;
	case xup: big_pic_y -= scroll_step; break;
	}
		
	big_pic_x <?= on_screen.width()  - screen_w - 1;
	big_pic_y <?= on_screen.height() - screen_h - 1;
	big_pic_x >?= 0;
	big_pic_y >?= 0;
	
	if (on_screen.x != big_pic_x || on_screen.y != big_pic_y) {
		on_screen.x = big_pic_x;
		on_screen.y = big_pic_y;
		on_screen.put();
	}
}

